local shoutcolor = SKINCOLOR_NONE
local shoutplayer
local shouttype = ""
local shoutxpos = 0
local shoutypos = 0

COM_AddCommand("shout", function(p, arg)
	if not netgame then
		CONS_Printf(p, "You can only do this in a netgame.")
		return
	end
	
	if not arg then
		CONS_Printf(p, "\x82shout <type>\x80 - Make a shout bubble appear on screen.")
		CONS_Printf(p, "\x82".."Available shout types\x80:")
		CONS_Printf(p, "\x82holdit\x80 - \"Hold it!\"")
		CONS_Printf(p, "\x82object\x80 - \"Objection!\"")
		CONS_Printf(p, "\x82takethat\x80 - \"Take that!\"")
		return
	elseif arg != "holdit" and arg != "object" and arg != "takethat" then
		CONS_Printf(p, "Invalid shout type.")
		return
	end
	
	shoutplayer = p
	shoutcolor = shoutplayer.mo.color
	shouttype = arg
	rawset(_G, "shoutprogress", 1)
	for p in players.iterate
		P_FlashPal(p, PAL_WHITE, TICRATE/4)
	end
	S_StartSound(nil, sfx_aaobje)
end)

addHook("MapLoad", do
	rawset(_G, "shoutprogress", 0)
end)

addHook("PlayerThink", function(player)
	if not (player.cmd.buttons & BT_CUSTOM1) then
		player.c1r = true
		player.c1d = false
	elseif player.c1r then
		player.c1d = true
		player.c1r = false
	else
		player.c1d = false
	end
	if not (player.cmd.buttons & BT_CUSTOM2) then
		player.c2r = true
		player.c2d = false
	elseif player.c2r then
		player.c2d = true
		player.c2r = false
	else
		player.c2d = false
	end
	if not (player.cmd.buttons & BT_CUSTOM3) then
		player.c3r = true
		player.c3d = false
	elseif player.c3r then
		player.c3d = true
		player.c3r = false
	else
		player.c3d = false
	end
	
	if player.c1d then
		COM_BufInsertText(player, "shout holdit")
	elseif player.c2d then
		COM_BufInsertText(player, "shout object")
	elseif player.c3d then
		COM_BufInsertText(player, "shout takethat")
	end
end)

hud.add(function(v, p, c)
	if not shoutprogress then return end
	
	if shoutprogress <= 17 then
		local randomang = AngleFixed(v.RandomRange(0, ANGLE_MAX))
		shoutxpos = (sin(randomang)*50)/FRACUNIT
		shoutypos = cos(randomang)/FRACUNIT
	else
		shoutxpos = 0
		shoutypos = 0
	end
	
	if shouttype == "holdit" then
		v.draw(160+shoutxpos, 100+shoutypos, v.cachePatch("AAHOLDIT"), 0, v.getColormap("sonic", shoutcolor))
	elseif shouttype == "object" then
		v.draw(160+shoutxpos, 100+shoutypos, v.cachePatch("AAOBJECT"), 0, v.getColormap("sonic", shoutcolor))
	elseif shouttype == "takethat" then
		v.draw(160+shoutxpos, 100+shoutypos, v.cachePatch("AATKTHAT"), 0, v.getColormap("sonic", shoutcolor))
	end
	
	if shoutprogress <= TICRATE then
		rawset(_G, "shoutprogress", shoutprogress+1)
	else
		rawset(_G, "shoutprogress", 0)
	end
end, "game")